/******************************************************************************
															 OptANSI Library
												 Copyright 1992 Michael Dannov
This source is subject to all restrictions specified by the licensing agreement
******************************************************************************/


/* Special Keys, Input Results with 0 followed by key value below */

#define UP 72 // 'H'
#define DOWN 80 // 'P'
#define LEFT 75 // 'K'
#define RIGHT 77 // 'M'
#define PGUP 73 // 'I'
#define PGDOWN 81 // 'Q'
#define HOME 71 // 'G'
#define END 79 // 'O'

#define CTRLLEFT 115 // 's'
#define CTRLRIGHT 116 // 't'
#define CTRLPGUP 132
#define CTRLPGDOWN 118 // 'v'
#define CTRLHOME 119 // 'w'
#define CTRLEND 117 // 'u'

#define CTRLPRINT 114 // 'r'
#define CTRLBREAK 3
#define CTRL2 3
#define SHFTTAB 15

#define F1 59 // ';'
#define F2 60 // '<'
#define F3 61 // '='
#define F4 62 // '>'
#define F5 63 // '?'
#define F6 64 // '@'
#define F7 65 // 'A'
#define F8 66 // 'B'
#define F9 67 // 'C'
#define F10 68 // 'D'
#define F11 133
#define F12 134

#define CTRLF1 94 // '^'
#define CTRLF2 95 // '_'
#define CTRLF3 96 // '`'
#define CTRLF4 97 // 'a'
#define CTRLF5 98 // 'b'
#define CTRLF6 99 // 'c'
#define CTRLF7 100 // 'd'
#define CTRLF8 101 // 'e'
#define CTRLF9 102 // 'f'
#define CTRLF10 103 // 'g'
#define CTRLF11 137
#define CTRLF12 138

#define SHFTF1 84 // 'T'
#define SHFTF2 85 // 'U'
#define SHFTF3 86 // 'X'
#define SHFTF4 87 // 'W'
#define SHFTF5 88 // 'X'
#define SHFTF6 89 // 'Y'
#define SHFTF7 90 // 'Z'
#define SHFTF8 91 // '['
#define SHFTF9 92 // '\\'
#define SHFTF10 93 // ']'
#define SHFTF11 135
#define SHFTF12 136

#define ALTF1 104 // 'h'
#define ALTF2 105 // 'i'
#define ALTF3 106 // 'j'
#define ALTF4 107 // 'k'
#define ALTF5 108 // 'l'
#define ALTF6 109 // 'm'
#define ALTF7 110 // 'n'
#define ALTF8 111 // 'o'
#define ALTF9 112 // 'p'
#define ALTF10 113 // 'q'
#define ALTF11 139 /* ? */
#define ALTF12 140 /* ? */

#define ALTA 30
#define ALTB 48 // '0'
#define ALTC 46 // '.'
#define ALTD 32 // ' '
#define ALTE 18
#define ALTF 33 // '!'
#define ALTG 34 // '"'
#define ALTH 35 // '#'
#define ALTI 22
#define ALTJ 36 // '$'
#define ALTK 37 // '%'
#define ALTL 38 // '&'
#define ALTM 50 // '2'
#define ALTN 51 // '1'
#define ALTO 24
#define ALTP 25
#define ALTQ 16
#define ALTR 19
#define ALTS 31
#define ALTT 20
#define ALTU 22
#define ALTV 47 // '/'
#define ALTW 17
#define ALTX 45 // '-'
#define ALTY 21
#define ALTZ 44 // ','
#define ALT1 120 // 'x'
#define ALT2 121 // 'y'
#define ALT3 122 // 'z'
#define ALT4 123 // '{'
#define ALT5 124 // '|'
#define ALT6 125 // '}'
#define ALT7 126 // '~'
#define ALT8 127
#define ALT9 128
#define ALT0 129
#define ALTMINUS 130
#define ALTEQUAL 131


/* Single key Combinations */

#define CTRL(c) c-'@'
#define CTRL6 30
#define CTRLBACKSPACE // ''

